'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.isequal');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactSwipeable = require('react-swipeable');

var _reactSwipeable2 = _interopRequireDefault(_reactSwipeable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AliceCarousel = function (_React$Component) {
    _inherits(AliceCarousel, _React$Component);

    function AliceCarousel() {
        _classCallCheck(this, AliceCarousel);

        var _this = _possibleConstructorReturn(this, (AliceCarousel.__proto__ || Object.getPrototypeOf(AliceCarousel)).call(this));

        _this.state = {
            slides: [],
            currentIndex: 1,
            style: {
                transition: 'transform 0ms ease-out' }
        };

        _this._slideNext = _this._slideNext.bind(_this);
        _this._slidePrev = _this._slidePrev.bind(_this);
        _this._onTouchEnd = _this._onTouchEnd.bind(_this);
        _this._onTouchMove = _this._onTouchMove.bind(_this);
        _this._resizeHandler = _this._resizeHandler.bind(_this);
        _this._keyDownHandler = _this._keyDownHandler.bind(_this);
        _this._getStageComponentNode = _this._getStageComponentNode.bind(_this);
        return _this;
    }

    _createClass(AliceCarousel, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this._allowAnimation();
            this._setInitialState();
            window.addEventListener('resize', this._resizeHandler);

            if (!this.props.keysControlDisabled) {
                window.addEventListener('keydown', this._keyDownHandler);
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (!(0, _lodash2.default)(this.props.children, nextProps.children)) {
                this.setState({
                    slides: nextProps.children,
                    clones: this._cloneSlides(nextProps.children)
                });
            }

            if (!(0, _lodash2.default)(this.props.responsive, nextProps.responsive)) {
                this.setState(this._calculateInitialProps(nextProps.responsive));
            }

            if (this.props.keysControlDisabled !== nextProps.keysControlDisabled) {
                nextProps.keysControlDisabled === true ? window.removeEventListener('keydown', this._keyDownHandler) : window.addEventListener('keydown', this._keyDownHandler);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('resize', this._resizeHandler);

            if (!this.props.keysControlDisabled) {
                window.removeEventListener('keydown', this._keyDownHandler);
            }
        }
    }, {
        key: '_cloneSlides',
        value: function _cloneSlides(children, itemsInSlide) {
            var slides = children || this.props.children;
            var items = itemsInSlide || this._setTotalItemsInSlide();
            var first = slides.slice(0, items);
            var last = slides.slice(slides.length - items);

            return last.concat(slides, first);
        }
    }, {
        key: '_calculateInitialProps',
        value: function _calculateInitialProps(totalItems) {
            var items = this._setTotalItemsInSlide(totalItems);
            var itemWidth = this.stageComponent.getBoundingClientRect().width / items;

            return {
                items: items,
                itemWidth: itemWidth,
                currentIndex: items,
                clones: this._cloneSlides(null, items),
                slides: this.props.children || [],
                translate3d: -itemWidth * items
            };
        }
    }, {
        key: '_setInitialState',
        value: function _setInitialState() {
            this.setState(this._calculateInitialProps());
        }
    }, {
        key: '_getStageComponentNode',
        value: function _getStageComponentNode(node) {
            this.stageComponent = node;
        }
    }, {
        key: '_getDuration',
        value: function _getDuration() {
            return this.props.duration || 250;
        }
    }, {
        key: '_allowAnimation',
        value: function _allowAnimation() {
            this.allowAnimation = true;
        }
    }, {
        key: '_resizeHandler',
        value: function _resizeHandler() {
            this._setInitialState();
        }
    }, {
        key: '_isInfinite',
        value: function _isInfinite() {
            var _state = this.state,
                items = _state.items,
                itemWidth = _state.itemWidth,
                slides = _state.slides,
                currentIndex = _state.currentIndex;

            var slidesLength = slides.length;
            var circle = currentIndex === 0 || currentIndex === slidesLength + items;

            if (circle) {
                this.setState({
                    currentIndex: currentIndex === 0 ? slidesLength : items,
                    translate3d: -itemWidth * (currentIndex === 0 ? slidesLength : items),
                    style: { transition: 'transform 0ms ease-out' }
                });
            }

            if (this.props.onSlideChange) {
                this.props.onSlideChange(this._getActiveSlideIndex());
            }
            this._allowAnimation();
        }
    }, {
        key: '_prevButton',
        value: function _prevButton() {
            return _react2.default.createElement(
                'div',
                { className: 'alice-carousel-prev' },
                _react2.default.createElement('div', { className: 'alice-carousel-prev__btn', onClick: this._slidePrev })
            );
        }
    }, {
        key: '_nextButton',
        value: function _nextButton() {
            return _react2.default.createElement(
                'div',
                { className: 'alice-carousel-next' },
                _react2.default.createElement('div', { className: 'alice-carousel-next__btn', onClick: this._slideNext })
            );
        }
    }, {
        key: '_getActiveSlideIndex',
        value: function _getActiveSlideIndex() {
            var _state2 = this.state,
                slides = _state2.slides,
                items = _state2.items,
                currentIndex = _state2.currentIndex;

            var slidesLength = slides.length;

            var dotsLength = slidesLength % items === 0 ? Math.floor(slidesLength / items) - 1 : Math.floor(slidesLength / items);

            if (items === 1) {
                if (currentIndex < items) {
                    return slidesLength - items;
                } else if (currentIndex > slidesLength) {
                    return 0;
                } else {
                    return currentIndex - 1;
                }
            } else {
                if (currentIndex === slidesLength + items) {
                    return 0;
                } else if (currentIndex < items && currentIndex !== 0) {
                    return dotsLength;
                } else if (currentIndex === 0) {
                    return slidesLength % items === 0 ? dotsLength : dotsLength - 1;
                } else {
                    return Math.floor(currentIndex / items) - 1;
                }
            }
        }
    }, {
        key: '_renderDotsNavigation',
        value: function _renderDotsNavigation() {
            var _this2 = this;

            var _state3 = this.state,
                slides = _state3.slides,
                items = _state3.items;


            return _react2.default.createElement(
                'ul',
                { className: 'alice-carousel-dots' },
                slides.map(function (item, i) {
                    if (i < slides.length / items) {
                        return _react2.default.createElement('li', {
                            key: i,
                            onClick: function onClick() {
                                return _this2._slideToItem(i + 1);
                            },
                            className: 'alice-carousel-dots__item' + (_this2._getActiveSlideIndex() === i ? ' __active' : '')
                        });
                    }
                })
            );
        }
    }, {
        key: '_setTotalItemsInSlide',
        value: function _setTotalItemsInSlide(totalItems) {
            var items = 1;
            var width = window.innerWidth;

            if (this.props.responsive) {
                var responsive = totalItems || this.props.responsive || {};

                if (Object.keys(responsive).length) {
                    Object.keys(responsive).forEach(function (key) {
                        if (key < width) items = Math.abs(responsive[key].items) || items;
                    });
                }
            }
            return items;
        }
    }, {
        key: '_keyDownHandler',
        value: function _keyDownHandler(e) {
            if (!this.allowAnimation) return;

            switch (e.keyCode) {
                case 37:
                    this._slidePrev();
                    break;
                case 39:
                    this._slideNext();
                    break;
            }
        }
    }, {
        key: '_slidePrev',
        value: function _slidePrev() {
            var _state4 = this.state,
                currentIndex = _state4.currentIndex,
                items = _state4.items;

            this._slideToItem((currentIndex - 1) / items);
        }
    }, {
        key: '_slideNext',
        value: function _slideNext() {
            var _state5 = this.state,
                currentIndex = _state5.currentIndex,
                items = _state5.items;

            this._slideToItem((currentIndex + 1) / items);
        }
    }, {
        key: '_slideToItem',
        value: function _slideToItem(index, position) {
            var _this3 = this;

            if (!this.allowAnimation) return;
            this.allowAnimation = false;

            var _state6 = this.state,
                items = _state6.items,
                itemWidth = _state6.itemWidth;

            var duration = this._getDuration();
            var translate = position || index * items * itemWidth;
            var currentIndex = index * items;

            this.setState({
                currentIndex: currentIndex,
                translate3d: -translate,
                style: { transition: 'transform ' + duration + 'ms ease-out' }
            });

            setTimeout(function () {
                return _this3._isInfinite();
            }, duration);
        }
    }, {
        key: '_onTouchMove',
        value: function _onTouchMove() {
            if (this.props.swipeDisabled) return;

            var _state7 = this.state,
                slides = _state7.slides,
                items = _state7.items,
                itemWidth = _state7.itemWidth,
                translate3d = _state7.translate3d;

            var maxPosition = (slides.length + items) * itemWidth;
            var direction = arguments[1] > 0 ? 'LEFT' : 'RIGHT';
            var position = translate3d - arguments[1];

            if (position >= 0 || Math.abs(position) >= maxPosition) {
                recalculatePosition();
            }

            this._setTransformAnimation(this.stageComponent, position, 0);
            this.swipePosition = { position: position, direction: direction };

            function recalculatePosition() {
                direction === 'RIGHT' ? position += -slides.length * itemWidth : position += maxPosition - items * itemWidth;

                if (position >= 0 || Math.abs(position) >= maxPosition) {
                    recalculatePosition();
                }
            }
        }
    }, {
        key: '_onTouchEnd',
        value: function _onTouchEnd() {
            if (this.props.swipeDisabled) return;
            this._allowAnimation();

            var _state8 = this.state,
                itemWidth = _state8.itemWidth,
                items = _state8.items;

            var swipePosition = Math.abs(this.swipePosition.position);
            var currentIndex = this.swipePosition.direction === 'LEFT' ? Math.floor(swipePosition / itemWidth) + 1 : Math.floor(swipePosition / itemWidth);

            var position = currentIndex * itemWidth;

            this._setTransformAnimation(this.stageComponent, -position, this._getDuration());
            this._slideToItem(currentIndex / items, position);
        }
    }, {
        key: '_setTransformAnimation',
        value: function _setTransformAnimation(element, position, durationMs) {
            var prefixes = ['Webkit', 'Moz', 'ms', 'O', ''];

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = prefixes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var value = _step.value;

                    element.style[value + 'Transform'] = 'translate3d(' + position + 'px, 0, 0)';
                    element.style[value + 'Transition'] = 'transform ' + durationMs + 'ms ease-out';
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this4 = this;

            var style = _extends({}, this.state.style, { transform: 'translate3d(' + this.state.translate3d + 'px, 0, 0)' });
            var slides = this.state.clones || this.state.slides;

            return _react2.default.createElement(
                'div',
                {
                    className: 'alice-carousel'
                },
                _react2.default.createElement(
                    _reactSwipeable2.default,
                    { onSwiping: this._onTouchMove, onSwiped: this._onTouchEnd },
                    _react2.default.createElement(
                        'div',
                        { className: 'alice-carousel-wrapper' },
                        _react2.default.createElement(
                            'ul',
                            { className: 'alice-carousel-stage', ref: this._getStageComponentNode, style: style },
                            slides.map(function (item, i) {
                                return _react2.default.createElement(
                                    'li',
                                    {
                                        className: 'alice-carousel-stage__item', key: i,
                                        style: { width: _this4.state.itemWidth + 'px' }
                                    },
                                    item
                                );
                            })
                        )
                    )
                ),
                !this.props.buttonsDisabled ? this._prevButton() : null,
                !this.props.buttonsDisabled ? this._nextButton() : null,
                !this.props.dotsDisabled ? this._renderDotsNavigation() : null
            );
        }
    }]);

    return AliceCarousel;
}(_react2.default.Component);

AliceCarousel.propTypes = {
    children: _react2.default.PropTypes.array.isRequired,
    onSlideChange: _react2.default.PropTypes.func,
    keysControlDisabled: _react2.default.PropTypes.bool,
    buttonsDisabled: _react2.default.PropTypes.bool,
    dotsDisabled: _react2.default.PropTypes.bool,
    swipeDisabled: _react2.default.PropTypes.bool,
    responsive: _react2.default.PropTypes.object,
    duration: _react2.default.PropTypes.number
};

exports.default = AliceCarousel;